unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Math, ExtCtrls, Buttons, Menus, OleServer,
  ExcelXP, IniFiles;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Button1: TButton;
    Edit1: TEdit;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    Memo1: TMemo;
    ScrollBar1: TScrollBar;
    Memo3: TMemo;
    Memo2: TMemo;
    Memo4: TMemo;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Memo5: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    N12: TMenuItem;
    Memo6: TMemo;
    Label1: TLabel;
    N13: TMenuItem;
    N19: TMenuItem;
    Timer2: TTimer;
    N26: TMenuItem;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    Label2: TLabel;
    Button5: TButton;
    N28: TMenuItem;
    N29: TMenuItem;
    N25: TMenuItem;
    Timer3: TTimer;
    Button6: TButton;
    Timer4: TTimer;
    N31: TMenuItem;
    N32: TMenuItem;
    Timer5: TTimer;
    N34: TMenuItem;
    procedure ComboADD;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MemoDraw(k:Integer);
    procedure TxRxrmCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure N26Click(Sender: TObject);
    procedure BitBtn1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn9MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure Button2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button5Click(Sender: TObject);
    procedure N28Click(Sender: TObject);
    procedure N25Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure N32Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Timer5Timer(Sender: TObject);
    procedure N34Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Stop:Boolean;
  da1: Array[1..12,0..7]of Boolean;
  fb1: Array[1..13]of Boolean;
  data: Array[1..2000,1..10] of Byte;
  data2:Array[1..2000,2..13] of Boolean;
  flagi1:Array[1..2000,0..7]of Boolean;
  flagi2:Array[1..2000,0..7]of Boolean;
  TimeN:Array[1..2000]of TDateTime;
  Nechto:Array[1..2000]of Boolean;
  Kadr:Integer;
  Config: record
    Vozduh:Integer;
    Temperature:Integer;
    KHH:Integer;
    DZ:Integer;
    StParam:Integer;
    InvAdapter:Boolean;
    DTR:Boolean;
    ZagrCP:Boolean;
    col:Array[1..6]of TColor;
    GrafikN:Array[1..6]of Integer;
    PrFors: Integer;
    KolFors:Integer;
    ChastFors: Integer;
    end;
  Proizv:String;   //  

  hCom : THANDLE;         //COM handle
  dcb  : TDCB;            //COM device control block
  ComTo: TCOMMTIMEOUTS;   //COM timeouts

const Version=7090;

implementation

uses PryamHi, Unit3, Unit4, Unit5, ObrHi, Unit6, Unit2, Unit7, Unit8, Unit9;

{$R *.dfm}

function PurgeCOM:boolean; stdcall;
begin
 Result:=PurgeComm(hCom,PURGE_TXABORT or
                        PURGE_RXABORT or
                        PURGE_TXCLEAR or
                        PURGE_RXCLEAR);
end;

function CloseCOM:boolean; stdcall;
begin
 Result:=CloseHandle(hCom);
end;

function OpenCOM(P:PChar):boolean; stdcall;
begin
 hCom:= CreateFile(P,
                   GENERIC_READ or GENERIC_WRITE,
                   0,
                   nil,
                   OPEN_EXISTING,
                   0,
                   0);
 if (hCom=INVALID_HANDLE_VALUE)
  then begin Result:=false; exit; end;
 if not GetCommState(hCom,dcb)
  then begin Result:=false; exit; end;
 if not GetCommTimeouts(hCom,ComTo)
  then begin Result:=false; exit; end;
 Result:=true;
end;

function SetCOMTo(RdIvl,RdTotM,RdTotC,
          WrTotM,WrTotC:DWORD):boolean; stdcall;
begin
 ComTo.ReadIntervalTimeout:=RdIvl;
 ComTo.ReadTotalTimeoutMultiplier:=RdTotM;
 ComTo.ReadTotalTimeoutConstant:=RdTotC;
 ComTo.WriteTotalTimeoutMultiplier:=WrTotM;
 ComTo.WriteTotalTimeoutConstant:=WrTotC;
 Result:=SetCommTimeouts(hCom,ComTo);
end;

function SetModCOM(baud:DWORD;bsize,parity,
                sbits:BYTE;DTR,RTS:boolean):boolean; stdcall;
begin
 dcb.BaudRate:=baud;
 dcb.Flags:=$00000001;
 if DTR then dcb.Flags:=dcb.Flags or $00000010;
 if RTS then dcb.Flags:=dcb.Flags or $00001000;
 dcb.ByteSize:=bsize;
 dcb.Parity:=parity;
 dcb.StopBits:=sbits;
 Result:=SetCommState(hCom,dcb);
end;

function AccessCOM(P:PChar):boolean; stdcall;
var hTemp: THANDLE;
begin
 hTemp:= CreateFile(P,
                    GENERIC_READ or GENERIC_WRITE,
                    0,
                    nil,
                    OPEN_EXISTING,
                    0,
                    0);
 if not (hTemp=INVALID_HANDLE_VALUE)
  then begin CloseHandle(hTemp); Result:=true;  end
  else Result:=false;
end;

procedure TForm1.ComboADD;
var
i,n:Integer;
items:Array[1..6] of Integer;
begin
  for n:=1 to 6 do
    items[n]:=TComboBox(Form3.FindComponent('ComboBox'+IntToStr(n))).ItemIndex;
  Form3.ComboBox1.Clear;
  Form3.ComboBox2.Clear;
  Form3.ComboBox3.Clear;
  Form3.ComboBox4.Clear;
  Form3.ComboBox5.Clear;
  Form3.ComboBox6.Clear;
  for i:=1 to 10 do
    begin
    Form3.ComboBox1.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox2.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox3.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox4.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox5.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox6.Items.Add(Form1.Memo1.Lines.Strings[i]);

    Form3.ComboBox1.Items.Add(Form1.Memo1.Lines.Strings[i]+'-()');
    Form3.ComboBox2.Items.Add(Form1.Memo1.Lines.Strings[i]+'-()');
    Form3.ComboBox3.Items.Add(Form1.Memo1.Lines.Strings[i]+'-()');
    Form3.ComboBox4.Items.Add(Form1.Memo1.Lines.Strings[i]+'-()');
    Form3.ComboBox5.Items.Add(Form1.Memo1.Lines.Strings[i]+'-()');
    Form3.ComboBox6.Items.Add(Form1.Memo1.Lines.Strings[i]+'-()');
    end;
  for i:=11 to 22 do
    begin
    Form3.ComboBox1.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox2.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox3.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox4.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox5.Items.Add(Form1.Memo1.Lines.Strings[i]);
    Form3.ComboBox6.Items.Add(Form1.Memo1.Lines.Strings[i]);
    end;
  Form3.ComboBox1.Items.Add('');
  Form3.ComboBox2.Items.Add('');
  Form3.ComboBox3.Items.Add('');
  Form3.ComboBox4.Items.Add('');
  Form3.ComboBox5.Items.Add('');
  Form3.ComboBox6.Items.Add('');
  for n:=1 to 6 do
    TComboBox(Form3.FindComponent('ComboBox'+IntToStr(n))).ItemIndex:=items[n];
end;

procedure SetOgranich(Sost:Boolean);
begin
  Stop:=Sost;
  Form1.ComboBox1.Enabled:=Sost;
  Form1.N1.Enabled:=Sost;
  Form1.N19.Enabled:=Sost;
  //Form1.N8.Enabled:=Sost;
  Form1.N13.Enabled:=Sost;
  Form1.N12.Enabled:=Sost;
  Form1.N6.Enabled:=Sost;
  Form1.Button5.Enabled:=Sost;
  Form1.Button6.Enabled:=Sost;
  if Sost=False then Form1.Button1.Caption:=''
    else Form1.Button1.Caption:='';
  if Sost=False then Form7.Button2.Caption:=''
    else Form7.Button2.Caption:='';
  Form3.ComboBox8.Enabled:=Sost;
  Form3.TrackBar1.Enabled:=Sost;
  Form3.ScrollBar1.Enabled:=Sost;
  Form3.Button1.Enabled:=Sost;
  Form3.Button2.Enabled:=Sost;
end;

procedure Form3Refr;
var i:Array[1..6] of Integer;
n:Integer;
begin
  for n:=1 to 6 do
    i[n]:=TComboBox(Form3.FindComponent('ComboBox'+IntToStr(n))).ItemIndex;
  Form1.ComboADD;
  for n:=1 to 6 do
    TComboBox(Form3.FindComponent('ComboBox'+IntToStr(n))).ItemIndex:=i[n];
  Form3.ComboBox1Change(Form1);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
port: String;
begin
  port:=Form1.ComboBox1.Text;
  PurgeCOM;
  CloseCOM;
  if OpenCOM(pchar(port)) then
   begin
    SetCOMTo(MAXDWORD,0,0,0,0);
    SetModCOM(57600,8,NOPARITY,oneSTOPBIT,Config.DTR,False);
   end
  else
   begin
    Application.MessageBox(pchar(port),'',MB_OK or MB_IconError);
    Exit;
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  MyIni:TIniFile;
  i:Integer;
begin
  Stop:=True;
  Form1.Timer4.Enabled:=False;
  Form1.Edit1.Text:='';
  Application.ProcessMessages;
  for i:=3 to 9 do
    TForm(Application.FindComponent('Form'+IntToStr(i))).Close;
  Application.ProcessMessages;
  MyIni:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'CarTesterByChem407.ini');
  MyIni.WriteInteger('Main','Version',Version);
  MyIni.WriteInteger('Param','Vozduh',Config.Vozduh);
  MyIni.WriteInteger('Param','Temperature',Config.Temperature);
  MyIni.WriteInteger('Param','KHH',Config.KHH);
  MyIni.WriteInteger('Param','DZ',Config.DZ);
  MyIni.WriteInteger('Param','Standart',Config.StParam);
  MyIni.WriteBool('Param','Adapter',Config.InvAdapter);
  MyIni.WriteBool('Param','DTR',Config.DTR);
  MyIni.WriteBool('Param','Param',Config.ZagrCP);
  MyIni.WriteInteger('Param','col1',Config.col[1]);
  MyIni.WriteInteger('Param','col2',Config.col[2]);
  MyIni.WriteInteger('Param','col3',Config.col[3]);
  MyIni.WriteInteger('Param','col4',Config.col[4]);
  MyIni.WriteInteger('Param','col5',Config.col[5]);
  MyIni.WriteInteger('Param','col6',Config.col[6]);

  MyIni.WriteInteger('Param','Grafik1',Config.GrafikN[1]);
  MyIni.WriteInteger('Param','Grafik2',Config.GrafikN[2]);
  MyIni.WriteInteger('Param','Grafik3',Config.GrafikN[3]);
  MyIni.WriteInteger('Param','Grafik4',Config.GrafikN[4]);
  MyIni.WriteInteger('Param','Grafik5',Config.GrafikN[5]);
  MyIni.WriteInteger('Param','Grafik6',Config.GrafikN[6]);

  MyIni.WriteInteger('Param','PrFors',Config.PrFors);
  MyIni.WriteInteger('Param','KolFors',Config.KolFors);
  MyIni.WriteInteger('Param','ChastFors',Config.ChastFors);
  MyIni.WriteString('Koment','Marka',Form6.Edit1.Text);
  MyIni.WriteString('Koment','DVS',Form6.Edit2.Text);
  MyIni.WriteString('Koment','Transm',Form6.Edit3.Text);

  MyIni.WriteInteger('FormPos','1X',Form1.Left);
  MyIni.WriteInteger('FormPos','1Y',Form1.Top);
  MyIni.WriteInteger('FormPos','3X',Form3.Left);
  MyIni.WriteInteger('FormPos','3Y',Form3.Top);
  MyIni.WriteInteger('FormPos','4X',Form4.Left);
  MyIni.WriteInteger('FormPos','4Y',Form4.Top);
  MyIni.WriteInteger('FormPos','5X',Form5.Left);
  MyIni.WriteInteger('FormPos','5Y',Form5.Top);
  MyIni.WriteInteger('FormPos','6X',Form6.Left);
  MyIni.WriteInteger('FormPos','6Y',Form6.Top);
  MyIni.WriteInteger('FormPos','7X',Form7.Left);
  MyIni.WriteInteger('FormPos','7Y',Form7.Top);
  MyIni.WriteInteger('FormPos','8X',Form8.Left);
  MyIni.WriteInteger('FormPos','8Y',Form8.Top);
  MyIni.WriteInteger('FormPos','9X',Form9.Left);
  MyIni.WriteInteger('FormPos','9Y',Form9.Top);
  MyIni.UpdateFile;
  MyIni.Free;

  for i:=0 to 20 do
    begin
    Sleep(100);
    Form1.Edit1.Text:=Form1.Edit1.Text+'.';
    Application.ProcessMessages;
    end;
  {Stop:=True;
  PurgeCOM;
  CloseCOM;
  AssignFile(F, ExtractFilePath(Application.ExeName)+'CarTester.cfg');
  Rewrite(F);
  Writeln(F, IntToStr(Vozduh));
  Writeln(F, IntToStr(Temperature));
  Writeln(F, IntToStr(KHH));
  if Form1.N3S1.Checked then Writeln(F, IntToStr(1));
  if Form1.N1GGTE1.Checked then Writeln(F, IntToStr(2));
  if Form1.N1JZGTE1.Checked then Writeln(F, IntToStr(3));
  if Form1.N3S1.Checked=False and Form1.N1GGTE1.Checked=False and Form1.N1JZGTE1.Checked=False then Writeln(F, IntToStr(0));
  if Form1.N14.Checked then Writeln(F, IntToStr(1)) else Writeln(F, IntToStr(0));
  if Form1.N24.Checked then Writeln(F, IntToStr(1)) else Writeln(F, IntToStr(0));
  if Form1.N27.Checked then Writeln(F, IntToStr(1)) else Writeln(F, IntToStr(0));
  Writeln(F, col[1]);
  Writeln(F, col[2]);
  Writeln(F, col[3]);
  Writeln(F, col[4]);
  Writeln(F, col[5]);
  Writeln(F, col[6]);
  CloseFile(F); }
  GrafObr.Free;
  Red0.Free;
  Green1.Free;
end;

function Res(i:Byte):Byte;
var
n,x:Integer;
begin
x:=0;
for n:=0 to 7 do
  if da1[i,n] then x:=x + 1 shl(n);
Result:=x;
end; 

function FileNam(s:String):String;
var
n,i:Integer;
a,x:String;
begin
  n:=StrLen(pchar(s));
  a:='';
  for i:=0 to n do
    begin
    if s[n-i]='\' then break;
    a:=a+s[n-i];
    end;
    n:=StrLen(pchar(a));
    x:='';
    for i:=0 to n do x:=x+a[n-i];
    Result:=x;
end;

procedure TForm1.MemoDraw(k:Integer);

var
i,n:Integer;
temper:String;
rash:Extended;
dan1:Array[1..28]of String;
dan2:Array[1..28]of String;
dan3:Array[1..28]of String;
begin
  for i:=1 to 28 do
    Dan1[i]:='';
  for i:=1 to 28 do
    dan2[i]:='';
  Dan1[1]:=':';
  for i:= 2 to 13 do
    if data2[k,i] then Dan2[1]:=Dan2[1]+'1'
      else Dan2[1]:=Dan2[1]+'0';

  dan1[2]:='1.  :';
  dan1[3]:='2.  :';
  case Config.KHH of
    1:temper:='(%  255)';
    2:temper:='()';
  end;
  dan1[4]:='3.   '+temper+':';
  dan1[5]:='4.   .:';
  case Config.Vozduh of
    1:temper:='MAP  :';
    2:temper:='MAP  ...:';
    3:temper:='MAP-T  :';
    4:temper:='MAP-T  ...:';
    5:temper:='MAF  /:';
    6:temper:='VAF, :';
  end;
  dan1[6]:='5.  '+temper;
  case Config.Temperature of
    1:temper:='(.)';
    2:temper:='(.)';
  end;
  dan1[7]:='6.  .'+temper+':';
  dan1[8]:='7.  ..';
  case Config.DZ of
    1:dan1[8]:=dan1[8]+',:';
    2:dan1[8]:=dan1[8]+',%:';
  end;
  dan1[9]:='8.  :';
  dan1[10]:='9.   :';
  dan1[11]:='10.   :';
  dan1[12]:='11.0  ...:';
  dan1[13]:='11.1   .:';
  dan1[14]:='11.4  :';
  dan1[15]:='11.5  .:';
  dan1[16]:='11.6  .:';
  dan1[17]:='12.0  :';
  dan1[18]:='12.1   .:';
  dan1[19]:='12.2  :';
  dan1[20]:='12.3  :';
  dan1[21]:='12.4   :';
  dan1[22]:='12.5   :';
  dan1[23]:='12.7  ?:';
  dan1[24]:='. /:';
  dan1[25]:='. /100:';
  dan1[26]:='';//'- ';
  dan1[27]:='/:';
  dan1[28]:=':';

  dan2[2]:= FloatToStrF(data[k,1]*0.125,ffFixed,4,3)+' .';
  Dan2[3]:= FloatToStrF(data[k,2]*0.47-30,ffFixed,3,1)+' .';
  case Config.KHH of
    1:Dan2[4]:= FloatToStrF(data[k,3]/255*100,ffFixed,3,1)+' %';
    2:Dan2[4]:= FloatToStrF(data[k,3],ffFixed,3,0)+' ';
  end;
  Dan2[5]:= FloatToStrF(data[k,4]*25,ffFixed,4,0)+' /';
  case Config.Vozduh of
    1:Dan2[6]:= FloatToStrF(data[k,5]*0.6515,ffFixed,3,1)+' kPa';
    2:Dan2[6]:= FloatToStrF(data[k,5]*4.886,ffFixed,4,0)+' ...';
    3:Dan2[6]:= FloatToStrF(data[k,5]*0.97,ffFixed,3,1)+' kPa';
    4:Dan2[6]:= FloatToStrF(data[k,5]*7.732,ffFixed,4,0)+' ...';
    5:Dan2[6]:= FloatToStrF(data[k,5],ffFixed,3,1)+' /c';
    6:Dan2[6]:= FloatToStrF(data[k,5]/255*5,ffFixed,3,2)+' ';
  end;
  case Config.Temperature of
    1: n:=data[k,6];
  else  n:=255-data[k,6];
  end;
case n of
  0..14:temper:=FloatToStrF((n - 5) * 2 - 60,ffFixed,3,1);
  15..38:temper:=FloatToStrF((n - 15) * 0.83 - 40,ffFixed,3,1);
  39..81:temper:=FloatToStrF((n - 39) * 0.47 - 20,ffFixed,3,1);
  82..134:temper:=FloatToStrF((n - 82) * 0.38,ffFixed,3,1);
  135..179:temper:=FloatToStrF((n - 135) * 0.44 + 20,ffFixed,3,1);
  180..209:temper:=FloatToStrF((n - 180) * 0.67 + 40,ffFixed,3,1);
  210..227:temper:=FloatToStrF((n - 210) * 1.11 + 60,ffFixed,3,1);
  228..236:temper:=FloatToStrF((n - 228) * 2.11 + 80,ffFixed,3,1);
  237..242:temper:=FloatToStrF((n - 237) * 3.83 + 99,ffFixed,3,1);
  243..255:temper:=FloatToStrF((n - 243) * 9.8 + 122,ffFixed,3,1);
end;
{case n of
  0..5:temper:='<-60';
  6..15:temper:=FloatToStrF(2.064*n-70.526,ffFixed,3,1);
  16..39:temper:=FloatToStrF(0.834*n-52.340,ffFixed,3,1);
  40..81:temper:=FloatToStrF(0.467*n-38.095,ffFixed,3,1);
  82..134:temper:=FloatToStrF(0.377*n-30.769,ffFixed,3,1);
  135..180:temper:=FloatToStrF(0.436*n-38.667,ffFixed,3,1);
  181..210:temper:=FloatToStrF(0.665*n-80,ffFixed,3,1);
  211..228:temper:=FloatToStrF(1.153*n-182.941,ffFixed,3,1);
  229..237:temper:=FloatToStrF(2.179*n-416.667,ffFixed,3,1);
  238..243:temper:=FloatToStrF(3.565*n-745.455,ffFixed,3,1);
  244..245:temper:=FloatToStrF(7.843*n-1784,ffFixed,3,1);
  246..255:temper:='>140';
end;}
  Dan2[7]:= temper+' .';
  case Config.DZ of
    1:Dan2[8]:= FloatToStrF(data[k,7]/2,ffFixed,3,1)+' .';
    2:Dan2[8]:= FloatToStrF(data[k,7]/1.8,ffFixed,3,1)+' %.';
  end;
  Dan2[9]:= FloatToStrF(data[k,8],ffFixed,3,0)+' /';
  Dan2[10]:= FloatToStrF(data[k,9]*5/256,ffFixed,3,2)+'';
  Dan2[11]:= FloatToStrF(data[k,10]*5/256,ffFixed,3,2)+'';
  if flagi1[k,0] then Dan2[12]:=''      //11.0 -  
    else Dan2[12]:='';
  if flagi1[k,1] then Dan2[13]:=''       //11.1 -  
    else Dan2[13]:='';
  if flagi1[k,4] then Dan2[14]:=''        //11.4 - 
    else Dan2[14]:='';
  if flagi1[k,5] then Dan2[15]:=''      //11.5 - A/F control
    else Dan2[15]:='';
  if flagi1[k,6] then Dan2[16]:=''     //11.6 - A/F control
    else Dan2[16]:='';

  if flagi2[k,0] then Dan2[17]:=''             //12.0 - 
    else Dan2[17]:='';
  if flagi2[k,1] then Dan2[18]:=''       //12.1 -  
    else Dan2[18]:='';
  if flagi2[k,2] then Dan2[19]:=''          //12.2 - 
    else Dan2[19]:='';
  if flagi2[k,3] then Dan2[20]:=''          //12.3 -   
    else Dan2[20]:='';
  if flagi2[k,4] then Dan2[21]:=''       //12.4 -  
    else Dan2[21]:='';
  if flagi2[k,5] then Dan2[22]:=''       //12.5 -  
    else Dan2[22]:='';
  if flagi2[k,7] then                                         //12.7 -    ????
    Dan2[23]:=''
  else
    Dan2[23]:='';
  if nechto[k] then Dan2[26]:=''//''
    else Dan2[26]:='';//'';
  Dan2[27]:=IntToStr(k)+' / '+IntToStr(Form1.ScrollBar1.Max);
  Dan2[28]:=TimeToStr(TimeN[k]);

  rash:=data[k,1]*data[k,4]*Config.ChastFors*Config.KolFors*Config.PrFors*0.00000625;
  dan2[24]:= FloatToStrF(rash,ffFixed,4,2);
  if data[k,8]<>0 then rash:=rash*100/data[k,8]
    else rash:=999;
  dan2[25]:= FloatToStrF(rash,ffFixed,3,1);

if Form1.Visible then
  begin
  Form1.Memo1.Clear;
  Form1.Memo2.Clear;
  for i:=1 to 28 do Form1.Memo1.Lines.Add(Dan1[i]);
  for i:=1 to 28 do Form1.Memo2.Lines.Add(Dan2[i]);
  end;
if Form7.Visible then
  begin
  Form7.Label36.Caption:=dan2[24]+'/';
  Form7.Label37.Caption:=dan2[25]+'/100';
  for i:=2 to 11 do
    TLabel(Form7.FindComponent('Label'+IntToStr(9+i))).Caption:=Dan2[i];
  if flagi1[k,0] then Form7.Draw1('Image1')      //11.0 -  
    else Form7.Draw0('Image1');
  if flagi1[k,1] then Form7.Draw1('Image2')       //11.1 -  
    else Form7.Draw0('Image2');
  if flagi1[k,4] then Form7.Draw1('Image3')        //11.4 - 
    else Form7.Draw0('Image3');
  if flagi1[k,5] then Form7.Draw1('Image4')      //11.5 - A/F control
    else Form7.Draw0('Image4');
  if flagi1[k,6] then Form7.Draw1('Image5')     //11.6 - A/F control
    else Form7.Draw0('Image5');

  if flagi2[k,0] then Form7.Draw1('Image6')             //12.0 - 
    else Form7.Draw0('Image6');
  if flagi2[k,1] then Form7.Draw1('Image7')      //12.1 -  
    else Form7.Draw0('Image7');
  if flagi2[k,2] then Form7.Draw1('Image8')          //12.2 - 
    else Form7.Draw0('Image8');
  if flagi2[k,3] then Form7.Draw1('Image9')          //12.3 -   
    else Form7.Draw0('Image9');
  if flagi2[k,4] then Form7.Draw1('Image10')      //12.4 -  
    else Form7.Draw0('Image10');
  if flagi2[k,5] then Form7.Draw1('Image11')       //12.5 -  
    else Form7.Draw0('Image11');
  if flagi2[k,7] then                                         //12.7 -    ????
    Form7.Draw1('Image12')
  else
    Form7.Draw0('Image12');
  Form7.Label34.Caption:=IntToStr(k)+' / '+IntToStr(Form1.ScrollBar1.Max);
  end;

if Form1.N12.Checked then
  begin
  for i:=1 to 26 do
    Dan3[i]:='';
  for i:= 1 to 10 do
    Dan3[i+1]:=IntToStr(data[k,i]);
  for i:=0 to 7 do
    begin
    if flagi1[k,i] then Dan3[12]:=Dan3[12]+'1'
      else Dan3[12]:=Dan3[12]+'0';
    if flagi2[k,i] then Dan3[17]:=Dan3[17]+'1'
      else Dan3[17]:=Dan3[17]+'0';
    end;
  if nechto[k] then Dan3[24]:='1'
      else Dan3[24]:='0';
  Form1.Memo6.Clear;
  for i:=1 to 26 do
    begin
    Form1.Memo6.Lines.Add(Dan3[i]);
    end;
  end;

end;

procedure FormRes(const i:Integer);
begin
  if not(Form1.N12.Checked) then
    if Form1.N13.Checked then
      begin
      Form1.Width:=556;
      Form1.Edit1.Width:=551;
      Form1.ScrollBar1.Width:=551;

      Form1.Memo3.Left:=256;
      Form1.Memo4.Left:=354;
      Form1.Memo5.Left:=452;
      Form1.Button2.Left:=269;
      Form1.Button3.Left:=367;
      Form1.Button4.Left:=465;
      Form1.Memo3.Visible:=True;
      Form1.Memo4.Visible:=True;
      Form1.Memo5.Visible:=True;
      Form1.Button2.Visible:=True;
      Form1.Button3.Visible:=True;
      Form1.Button4.Visible:=True;

      Form1.Label1.Visible:=False;
      Form1.Label2.Visible:=False;
      Form1.Memo6.Visible:=False;
      end
    else
      begin
      Form1.Width:=265;
      Form1.Edit1.Width:=259;
      Form1.ScrollBar1.Width:=259;

      Form1.Memo3.Visible:=False;
      Form1.Memo4.Visible:=False;
      Form1.Memo5.Visible:=False;
      Form1.Button2.Visible:=False;
      Form1.Button3.Visible:=False;
      Form1.Button4.Visible:=False;

      Form1.Label1.Visible:=False;
      Form1.Label2.Visible:=False;
      Form1.Memo6.Visible:=False;
      end
  else
    if Form1.N13.Checked then
      begin
      Form1.Width:=656;
      Form1.Edit1.Width:=651;
      Form1.ScrollBar1.Width:=651;

      Form1.Memo3.Left:=356;
      Form1.Memo4.Left:=454;
      Form1.Memo5.Left:=552;
      Form1.Button2.Left:=369;
      Form1.Button3.Left:=467;
      Form1.Button4.Left:=565;
      Form1.Memo3.Visible:=True;
      Form1.Memo4.Visible:=True;
      Form1.Memo5.Visible:=True;
      Form1.Button2.Visible:=True;
      Form1.Button3.Visible:=True;
      Form1.Button4.Visible:=True;

      Form1.Label1.Visible:=True;
      Form1.Label2.Visible:=True;
      Form1.Memo6.Visible:=True;
      end
    else
      begin
      Form1.Width:=363;
      Form1.Edit1.Width:=357;
      Form1.ScrollBar1.Width:=357;

      Form1.Memo3.Visible:=False;
      Form1.Memo4.Visible:=False;
      Form1.Memo5.Visible:=False;
      Form1.Button2.Visible:=False;
      Form1.Button3.Visible:=False;
      Form1.Button4.Visible:=False;

      Form1.Label1.Visible:=True;
      Form1.Label2.Visible:=True;
      Form1.Memo6.Visible:=True;
      end;
  Form1.MemoDraw(Form1.ScrollBar1.Position);
end;

procedure Load(nameF: String);
var
  F: TextFile;
  s:String;
  i,n:Integer;
begin
  SetOgranich(True);
  for n:=1 to 2000 do
    for i:=1 to 26 do
      Data[n,i]:=0;
  if nameF='' then
    begin
    Form1.OpenDialog1.Execute;
    nameF:=Form1.OpenDialog1.FileName;
    end;
  if not FileExists(nameF) then exit;
    AssignFile(F, nameF);
    Reset(F);
    Readln(F, s);
    if (s='File for CarTester 1.0.0.1')or(s='File for CarTester 1.0.0.2')or(s='File for CarTester 1.0.0.3') then
      begin
      Readln(F, s);
      Kadr:=StrToInt(s);
      for n:=1 to Kadr do
        begin
        for i:=1 to 10 do
          begin
          Readln(F, s);
          Data[n,i]:=StrToInt(s);
          end;
        for i:=1 to 13 do
          begin
          Readln(F, s);
          if s='1' then Data2[n,i]:=True
            else Data2[n,i]:=False;
          end;
        for i:=0 to 7 do
          begin
          Readln(F, s);
          if s='1' then Flagi1[n,i]:=True
            else Flagi1[n,i]:=False;
          end;
        for i:=0 to 7 do
          begin
          Readln(F, s);
          if s='1' then Flagi2[n,i]:=True
            else Flagi2[n,i]:=False;
          end;
        Readln(F, s);
        if s='1' then Nechto[n]:=True
          else Nechto[n]:=False;
        Readln(F, s);
        TimeN[n] :=StrToTime(s);
        end;
      Form1.Memo3.Clear;
      Form1.Memo4.Clear;
      Form1.Memo5.Clear;
      for i:=1 to 25 do
        begin
        Readln(F, s);
        Form1.Memo3.Lines.Add(s);
        Readln(F, s);
        Form1.Memo4.Lines.Add(s);
        Readln(F, s);
        Form1.Memo5.Lines.Add(s);
        end;
      for i:=1 to 10 do                  //  
        begin
        Readln(F, s);
        if s='' then s:='0';
        TBitBtn(Form1.FindComponent('BitBtn'+IntToStr(i))).Caption:=s;
        end;
      Readln(F, s);                         // 
      Form6.Memo1.Clear;
      if s<>'' then
        for i:=0 to StrToInt(s) do
          begin
          Readln(F, s);
          Form6.Memo1.Lines.Add(s) ;
          end;
      Readln(F, s);                         // 
      Form6.Memo2.Clear;
      if s<>'' then
        for i:=0 to StrToInt(s) do
          begin
          Readln(F, s);
          Form6.Memo2.Lines.Add(s) ;
          end;
      Readln(F, s);
      if s<>'' then Form6.Edit1.Text:=s;
      Readln(F, s);
      if s<>'' then Form6.Edit2.Text:=s;
      Readln(F, s);
      if s<>'' then Form6.Edit3.Text:=s;
      CloseFile(F);
      Form1.MemoDraw(Kadr);
      Form1.ScrollBar1.Max:=Kadr;
      Form1.ScrollBar1.Position:=Kadr;
      Kadr:=Kadr+1;
      Form1.Edit1.Text:=' : '+FileNam(nameF) ;
      end
    else Form1.Edit1.Text:='   ';
  if Form3.Visible then
    begin
    Form3.Close;
    Form3.Show;
    Form3Refr;
    end;
  if Form6.Memo1.Lines.Count>0 then
    begin
    Form6.Show;
    Form6.Button1.SetFocus;
    end;
  if (Form1.Memo3.Lines[0]<>'')or(Form1.Memo4.Lines[0]<>'')or(Form1.Memo5.Lines[0]<>'') then
    begin
    Form1.N13.Checked:=not(Form1.N13.Checked);
    Application.ProcessMessages;
    FormRes(1);
    end;
   // N13Click(Form1);
end;

procedure Save;
var
  F: TextFile;
  i,n: Integer;
  S:String;
begin
  if Form6.Memo2.Lines.Count<1 then
    begin
    Form6.Show;
    ShowMessage('   !');
    exit;
    end;
  SetOgranich(True);
  repeat
    Application.ProcessMessages;
    Sleep(100);
  until Form1.Timer1.Enabled=False;
  if (Form1.SaveDialog1.Execute) and (Form1.SaveDialog1.FileName<>'') then
  begin
    if Form1.SaveDialog1.FilterIndex=1 then     //.ctr
      begin
      Form1.SaveDialog1.DefaultExt:='.ctr';
      Form1.SaveDialog1.FileName:=ChangeFileExt(Form1.SaveDialog1.FileName, Form1.SaveDialog1.DefaultExt);
      AssignFile(F, Form1.SaveDialog1.FileName);
      try
        Rewrite(F);
      except
        ShowMessage('   .');
        exit;
      end;
      Writeln(F, 'File for CarTester 1.0.0.3');
      Writeln(F, IntToStr(Form1.ScrollBar1.Max));
      for n:=1 to Form1.ScrollBar1.Max do
        begin
        for i:=1 to 10 do
          Writeln(F, Data[n,i]);
        for i:=1 to 13 do
          if Data2[n,i] then Writeln(F, '1')
            else Writeln(F, '0');
        for i:=0 to 7 do
          if Flagi1[n,i] then Writeln(F, '1')
            else Writeln(F, '0');
        for i:=0 to 7 do
          if Flagi2[n,i] then Writeln(F, '1')
            else Writeln(F, '0');
        if Nechto[n] then Writeln(F, '1')
            else Writeln(F, '0');
        Writeln(F, TimeToStr(TimeN[n]));
        end;
      For i:=0 to 24 do
        begin
        Writeln(F,Form1.Memo3.Lines[i]);
        Writeln(F,Form1.Memo4.Lines[i]);
        Writeln(F,Form1.Memo5.Lines[i]);
        end;
      for i:=1 to 10 do      //  
        begin
        S:=TBitBtn(Form1.FindComponent('BitBtn'+IntToStr(i))).Caption;
        WriteLn(F,S);
        end;
      WriteLn(F,IntToStr(Form6.Memo1.Lines.Count-1));  // 
      for i:=0 to Form6.Memo1.Lines.Count-1 do
        begin
        S:=Form6.Memo1.Lines.Strings[i] ;
        WriteLn(F,S);
        end;
      WriteLn(F,IntToStr(Form6.Memo2.Lines.Count-1));  // 
      for i:=0 to Form6.Memo2.Lines.Count-1 do
        begin
        S:=Form6.Memo2.Lines.Strings[i] ;
        WriteLn(F,S);
        end;
      S:=Form6.Edit1.Text;
      WriteLn(F,S);
      S:=Form6.Edit2.Text;
      WriteLn(F,S);
      S:=Form6.Edit3.Text;
      WriteLn(F,S);
      CloseFile(F);
      Form1.Edit1.Text:=' : '+FileNam(Form1.SaveDialog1.FileName) ;
    end;
    if Form1.SaveDialog1.FilterIndex=2 then     //csv - excel
      begin
      Form1.SaveDialog1.DefaultExt:='.csv';
      Form1.SaveDialog1.FileName:=ChangeFileExt(Form1.SaveDialog1.FileName, Form1.SaveDialog1.DefaultExt);
      AssignFile(F, Form1.SaveDialog1.FileName);
      try
        Rewrite(F);
      except
        ShowMessage('   .');
        exit;
      end;
      Writeln(F, '  CarTester;;;;;;'+IntToStr(Form1.ScrollBar1.Max)+' ');
      Writeln(F, ';1:A;2:A;3:A;4:A;5:A;6:A;7:A;8:A;9:A;10:A;;11:0;11:1;11:2;11:3;11:4;11:5;11:6;11:7;12:0;12:1;12:2;12:3;12:4;12:5;12:6;12:7;;');
      for n:=1 to Form1.ScrollBar1.Max do
        begin
        S:=IntToStr(n)+';';
        for i:=1 to 10 do
          S:=S+IntToStr(Data[n,i])+';';
        for i:=1 to 13 do
          if Data2[n,i] then S:=S+'1'
            else S:=S+'0';
        s:=s+';';
        for i:=0 to 7 do
          if Flagi1[n,i] then S:=S+'1;'
            else S:=S+'0;';
        for i:=0 to 7 do
          if Flagi2[n,i] then S:=S+'1;'
            else S:=S+'0;';
        if Nechto[n] then S:=S+'1;'
            else S:=S+'0;';
        S:=S+TimeToStr(TimeN[n]);
        WriteLn(F,S);
        end;
      WriteLn(F,'');             //    
      for n:=3 to 5 do
        begin
        S:=''+IntToStr(n-2);
        WriteLn(F,S);
        for i:= 0 to 27 do
          begin
          S:=TMemo(Form1.FindComponent('Memo'+IntToStr(n))).Lines[i];
          WriteLn(F,S);
          end;
        WriteLn(F,'');
        end;
      {S:=' 1; 2; 3';
      WriteLn(F,S);
      for i:= 0 to 24 do
        begin
        S:='';
        for n:=3 to 5 do
          S:=S+TMemo(Form1.FindComponent('Memo'+IntToStr(n))).Lines[i]+';';
        WriteLn(F,S);
        end;}
      for i:=0 to Form6.Memo1.Lines.Count-1 do
        begin
        S:=Form6.Memo1.Lines.Strings[i] ;
        WriteLn(F,S);
        end;
      Form1.Edit1.Text:=' : '+FileNam(Form1.SaveDialog1.FileName) ;
      CloseFile(F);
      end;
    end;
end;

procedure TForm1.TxRxrmCreate(Sender: TObject);
var
  i:Byte;
begin
  Stop:=True;
  for i:=1 to 50 do
    if AccessCOM(PChar('COM'+IntToStr(i))) then Form1.ComboBox1.Items.Add(PChar('COM'+IntToStr(i)));
  Kadr:=1;
  if ParamCount>0 then           //     
    Form1.Timer2.Enabled:=True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Mytr:Thread;
Mytr2:Thread2;
begin
  if Form1.Button1.Caption='' then
    begin
    if Form1.ComboBox1.Text='' then
      ShowMessage('   ')
    else
      begin
      Kadr:=1;
      Form4.Close();
      Form5.Close();
      Form6.Close();
      SetOgranich(False);
      Form6.Memo1.Clear;
      if Config.InvAdapter then
          begin
          Mytr2:=Thread2.Create(True);
          Mytr2.Priority:=tpTimeCritical		;
          Mytr2.Resume;
          end
        else
          begin
          Mytr:=Thread.Create(True);
          Mytr.Priority:=tpTimeCritical		;
          Mytr.Resume;
          end;
      Form1.Edit1.Text:=' ....';
      end;
    end
  else
    begin
    SetOgranich(True);
    Form1.Edit1.Text:=' ....';
    end;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
i:Integer;
begin
for i:=1 to 10 do
  data[kadr,i]:=Res(i);
for i:=2 to 13 do
  data2[kadr,i]:=fb1[i];
for i:= 0 to 7 do
  if da1[11,i] then flagi1[kadr,i]:=True
    else flagi1[kadr,i]:=False;
for i:= 0 to 7 do
  if da1[12,i] then flagi2[kadr,i]:=True
    else flagi2[kadr,i]:=False;
TimeN[kadr]:=Now;
Form1.ScrollBar1.Max:=Kadr;
Form1.ScrollBar1.Position:=Kadr;
Form7.ScrollBar1.Max:=Kadr;
Form7.ScrollBar1.Position:=Kadr;
MemoDraw(Kadr);
if Form3.Visible then Form1.Timer5.Enabled:=True;
Kadr:=Kadr+1;
Timer1.Enabled:=False;
if Kadr>2000 then
  begin
  SetOgranich(True);
  Save;
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
n:Integer;
begin
  if Stop=True then
  begin
  n:=Form1.ScrollBar1.Position;
  MemoDraw(n);
  Form7.ScrollBar1.Position:=Form1.ScrollBar1.Position;
  Form7.ScrollBar1.Max:=Form1.ScrollBar1.Max;
  if Form3.Visible then
    begin
    if Form3.ScrollBar1.Position>Form1.ScrollBar1.Position then Form3.ScrollBar1.Position:=Form1.ScrollBar1.Position;
    if (Form3.ScrollBar1.Position+Form3.TrackBar1.Max)<Form1.ScrollBar1.Position then Form3.ScrollBar1.Position:=Form1.ScrollBar1.Position-Form3.TrackBar1.Max;
    Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
    end;
  end;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Load('');
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  Save;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
  Stop:=True;
  Form4.Show;
end;

procedure TForm1.N8Click(Sender: TObject);
begin
  Form3.Show;
  ComboADD;
  Form3Refr;
end;

procedure TForm1.N12Click(Sender: TObject);
begin
  Form1.N12.Checked:=not(Form1.N12.Checked);
  Application.ProcessMessages;
  FormRes(1);
end;

procedure TForm1.N13Click(Sender: TObject);
begin
  Form1.N13.Checked:=not(Form1.N13.Checked);
  Application.ProcessMessages;
  FormRes(1);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  Timer2.Enabled:=False;
  Form9.FormCreate(Form1);
  Load(ParamStr(1));
end;

procedure TForm1.N26Click(Sender: TObject);
begin
  Stop:=True;
  Form5.Show;
end;

procedure TForm1.BitBtn1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn1.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn1.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn1.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn1.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn2.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn2.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn2.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn2.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn3.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn3.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn3.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn3.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn4.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn4.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn4.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn4.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn5.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn5.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn5.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn5.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn6.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn6.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn6.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn6.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn7.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn7.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn7.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn7.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn8.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn8.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn8.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn8.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn9MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn9.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn9.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn9.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn9.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;

procedure TForm1.BitBtn10MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
    begin
    Form1.BitBtn10.Caption:='0';
    end;
  if Button=mbLeft then
    begin
    if Form1.BitBtn10.Caption<>'0' then
      begin
      Form1.ScrollBar1.Position:=StrToInt(Form1.BitBtn10.Caption);
      if Form3.Visible then Form3.TrackBar1.Position:=Form1.ScrollBar1.Position-Form3.ScrollBar1.Position;
      end
      else Form1.BitBtn10.Caption:=IntToStr(Form1.ScrollBar1.Position);
    end;
end;


procedure TForm1.FormResize(Sender: TObject);
var ii,form:Integer;
begin
      form:=Form1.Width-5;
      for ii:=1 to 5 do
        begin
        TBitBtn(Form1.FindComponent('BitBtn'+IntToStr(ii))).Left:=Round((ii-1)*(form/5));
        TBitBtn(Form1.FindComponent('BitBtn'+IntToStr(ii+5))).Left:=Round((ii-1)*(form/5));
        TBitBtn(Form1.FindComponent('BitBtn'+IntToStr(ii))).Width:=Round(form/5.05);
        TBitBtn(Form1.FindComponent('BitBtn'+IntToStr(ii+5))).Width:=Round(form/5.05);
        Application.ProcessMessages;
        end;
end;

procedure TForm1.Button2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then Form1.Memo3.Clear;
  if Button=mbLeft then Form1.Memo3.Text:=Form1.Memo2.Text;
end;

procedure TForm1.Button3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then Form1.Memo4.Clear;
  if Button=mbLeft then Form1.Memo4.Text:=Form1.Memo2.Text;
end;

procedure TForm1.Button4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then Form1.Memo5.Clear;
  if Button=mbLeft then Form1.Memo5.Text:=Form1.Memo2.Text;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
i,ii,Mashtab:Integer;
begin
  if Form1.ScrollBar1.Max=1 then ShowMessage('   ?     ;)')
  else
  begin
  if not(Form1.ScrollBar1.Position=Form1.ScrollBar1.Max) then
    for i:=Form1.ScrollBar1.Position+1 to Form1.ScrollBar1.Max do
      begin
      for ii:= 1 to 10 do data[i-1,ii]:=data[i,ii];
      for ii:= 1 to 13 do data2[i-1,ii]:=data2[i,ii];
      for ii:= 1 to 7 do flagi1[i-1,ii]:=flagi1[i,ii];
      for ii:= 1 to 7 do flagi2[i-1,ii]:=flagi2[i,ii];
      TimeN[i-1]:=TimeN[i];
      Nechto[i-1]:=Nechto[i];
      end;
  Form1.ScrollBar1.Max:=Form1.ScrollBar1.Max-1;
  MemoDraw(Form1.ScrollBar1.Position);
  if Form3.Visible then
    begin
    if Form3.ComboBox8.Text=IntToStr(Form1.ScrollBar1.Max+1) then
      Form3.ComboBox8.Text:=IntToStr(Form1.ScrollBar1.Max);
    Mashtab:=Form1.ScrollBar1.Max;
    Form3.ComboBox8.Items.Clear;
    Form3.ComboBox8.Items.Add('5');
    if Mashtab>9 then Form3.ComboBox8.Items.Add('10');
    if Mashtab>19 then Form3.ComboBox8.Items.Add('20');
    if Mashtab>49 then Form3.ComboBox8.Items.Add('50');
    if Mashtab>99 then Form3.ComboBox8.Items.Add('100');
    if Mashtab>199 then Form3.ComboBox8.Items.Add('200');
    if Mashtab>499 then Form3.ComboBox8.Items.Add('500');
    if Mashtab>999 then Form3.ComboBox8.Items.Add('1000');
    if Mashtab>1999 then Form3.ComboBox8.Items.Add('2000');
    if Mashtab>5 then Form3.ComboBox8.Items.Add(IntToStr(Mashtab));
    Form3.ComboBox4Change(Form1);
    end;
  end;
end;

procedure TForm1.N28Click(Sender: TObject);
begin
  Form6.Show;
end;

procedure TForm1.N25Click(Sender: TObject);
var
  Pr:PrPr;
begin
  if Form1.ComboBox1.Text='' then
    begin
    ShowMessage('  .');
    exit;
    end
  else
  begin
  Pr:=PrPr.Create(True);
  Pr.Priority:=tpTimeCritical		;
  Pr.Resume;
  end;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  Form1.Timer3.Enabled:=False;
  ShowMessage(Proizv);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
if Form1.Timer4.Enabled then
  begin
  Form1.Timer4.Enabled:=False;
  Form1.Button6.Caption:='>';
  Form7.Button3.Caption:='>';
  end
else
  if Form1.ScrollBar1.Position=Form1.ScrollBar1.Max then Form1.Edit1.Text:='  ?'
    else
    begin
    Form1.Button6.Caption:='#';
    Form7.Button3.Caption:='#';
    Form1.Timer4.Enabled:=True;
    end
end;

procedure TForm1.Timer4Timer(Sender: TObject);
begin
  if Form1.ScrollBar1.Position=Form1.ScrollBar1.Max then
    begin
    Form1.Button6.Caption:='>';
    Form1.Timer4.Enabled:=False;
    end
  else
    begin
    if Form3.Visible then
      begin
      if Form3.TrackBar1.Position=Form3.TrackBar1.Max then Form3.ScrollBar1.Position:=Form3.ScrollBar1.Position+1
        else Form3.TrackBar1.Position:=Form3.TrackBar1.Position+1;
      end
    else Form1.ScrollBar1.Position:=Form1.ScrollBar1.Position+1;
    end;
end;

procedure TForm1.N31Click(Sender: TObject);
begin
  Form1.Hide;
  Form7.Show;
end;

procedure TForm1.N32Click(Sender: TObject);
begin
  if Form1.ComboBox1.Text='' then
      ShowMessage('   ')
  else
      begin
      Form1.Visible:=False;
      Form8.Show;
      end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  Form7.Edit1.Text:=Form1.Edit1.Text;
end;

procedure TForm1.Timer5Timer(Sender: TObject);
var
n:Integer;
begin
  Form1.Timer5.Enabled:=False;
  n:=Form1.ScrollBar1.Position;
  if n>50 then
    begin
    Form3.TrackBar1.Max:=49;
    Form3.TrackBar1.Position:=49;
    Form3.ScrollBar1.Max:=n-49;
    Form3.ScrollBar1.Position:=n-49;
    Mashtab:=50;
    Form3.ComboBox8.Text:='50';
    end
  else
    begin
    Form3.TrackBar1.Max:=n-1;
    Form3.TrackBar1.Position:=n-1;
    Form3.ScrollBar1.Max:=1;
    Form3.ScrollBar1.Position:=1;
    Mashtab:=n;
    Form3.ComboBox8.Text:=IntToStr(Mashtab);
    end;
  Form3.FormRefresh(n-Mashtab+1);
end;

procedure TForm1.N34Click(Sender: TObject);
begin
  Form9.Show;
end;

end.
