unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,Unit1,Math, ComCtrls, Buttons;

type
  TForm3 = class(TForm)
    ScrollBar1: TScrollBar;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Image1: TImage;
    TrackBar1: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox8: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    ColorDialog1: TColorDialog;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormRefresh(n:integer);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
  Mashtab:Integer;
  ColorStream:Array[0..200] of TColor;   //       
  Posit:Integer;
  GrafObr:TBitmap;

implementation

{$R *.dfm}

procedure SetColor;
var
col:Tcolor;
i:Integer;
begin
  for i:=1 to 6 do
    begin
    col:=TSpeedButton(Form3.FindComponent('SpeedButton'+IntToStr(i))).Font.Color;
    TLabel(Form3.FindComponent('Label'+IntToStr(i+8))).Font.Color:=col;
    TLabel(Form3.FindComponent('Label'+IntToStr(i+14))).Font.Color:=col;
    TLabel(Form3.FindComponent('Label'+IntToStr(i+20))).Font.Color:=col;
    TLabel(Form3.FindComponent('Label'+IntToStr(i+26))).Font.Color:=col;
    TComboBox(Form3.FindComponent('ComboBox'+IntToStr(i))).Font.Color:=col;
    end;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  Form3.Image1.Canvas.Create;
  Form3.Hide;
  SetColor;
  GrafObr:=TBitmap.Create;
  GrafObr.Width:=601;
  GrafObr.Height:=201;
end;

procedure GetLine(x:Integer);
var
i:Integer;
begin
  for i:=0 to 200 do
    begin
     ColorStream[i]:=GrafObr.Canvas.Pixels[x,i];
    end;
  Posit:=x;
end;

procedure WriteLine();
var
i:Integer;
begin
  for i:=0 to 200 do
    begin
    GrafObr.Canvas.Pen.Color:=ColorStream[i];
    GrafObr.Canvas.MoveTo(Posit,i);
    GrafObr.Canvas.LineTo(Posit,i+1);
    end;
end;

procedure PaintPanel(start:integer;graf:Integer);
var
i,n,abc,abc2,y1,y2,yy:Integer;
v:Extended;
begin
  if Mashtab<2 then exit;
  GrafObr.Canvas.Pen.Color:=TSpeedButton(Form3.FindComponent('SpeedButton'+IntToStr(graf))).Font.Color;
  GrafObr.Canvas.Pen.Width:=2;
  for i:= 0 to Mashtab-1 do
    begin
    abc:=ceil(600/(Mashtab-1)*i);
    abc2:=ceil(600/(Mashtab-1)*(i+1));
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=0 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption :='30';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption :='15';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption :='0';
      GrafObr.Canvas.MoveTo(abc,199-ceil(data[start+i,1]*0.83));
      GrafObr.Canvas.LineTo(abc2,199-ceil(data[start+i+1,1]*0.83));
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=1 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption :='30';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption :='15';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption :='0';
      y1:=0;
      y2:=0;
      for yy:=-3 to 3 do
        if (yy+i+Start>0)and(yy+i<Form1.ScrollBar1.Max) then
          begin
          y1:=y1+Round(data[start+i+yy,1]*0.83);
          end;
      for yy:=-2 to 4 do
        if (yy+i+Start>0)and(yy+i<Form1.ScrollBar1.Max) then
          begin
          y2:=y2+Round(data[start+i+yy,1]*0.83);
          end;
      GrafObr.Canvas.MoveTo(abc,199-Round(y1/7));
      GrafObr.Canvas.LineTo(abc2,199-Round(y2/7));
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=2 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='100';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='0';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='-100';
      GrafObr.Canvas.MoveTo(abc,99-ceil(data[start+i,2]*0.47-30));
      GrafObr.Canvas.LineTo(abc2,99-ceil(data[start+i+1,2]*0.47-30));
      end;
    case Config.KHH of
      1:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=2) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='100';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='50';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,3]/1.28));
          GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,3]/1.28));
          end;
      2:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=2) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='255';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='127';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,3]/1.28));
          GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,3]/1.28));
          end;
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=3 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='10000';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='5000';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
      GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,4]/2));
      GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,4]/2));
      end;
    case Config.Vozduh of
      1:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='133';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='66';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,199-data[start+i,5]);
          GrafObr.Canvas.LineTo(abc2,199-data[start+i+1,5]);
          end;
      2:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='1000';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='500';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,199-data[start+i,5]);
          GrafObr.Canvas.LineTo(abc2,199-data[start+i+1,5]);
          end;
      3:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='200';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='100';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,5]));
          GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,5]));
          end;
      4:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='1500';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='750';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,5]));
          GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,5]));
          end;
      5:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='200/';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='100/';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0/';
          GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,5]));
          GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,5]));
          end;
      6:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
          begin
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='5';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='2,5';
          TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
          GrafObr.Canvas.MoveTo(abc,ceil(199-data[start+i,5]/1.28));
          GrafObr.Canvas.LineTo(abc2,ceil(199-data[start+i+1,5]/1.28));
          end;
    end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=5 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='150';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='50';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='-50';
        case Config.Temperature of
        1: n:=data[start+i,6];
        else n:=255-data[start+i,6];
        end;
      case n of
        0..14:v:=(n - 5) * 2 - 60;
        15..38:v:=(n - 15) * 0.83 - 40;
        39..81:v:=(n - 39) * 0.47 - 20;
        82..134:v:=(n - 82) * 0.38;
        135..179:v:=(n - 135) * 0.44 + 20;
        180..209:v:=(n - 180) * 0.67 + 40;
        210..227:v:=(n - 210) * 1.11 + 60;
        228..236:v:=(n - 228) * 2.11 + 80;
        237..242:v:=(n - 237) * 3.83 + 99;
        243..255:v:=(n - 243) * 9.8 + 122;
      else v:=0;
      end;
      {case n of
        0..5: v:=-60;
        6..15: v:=2.064*n-70.526;
        16..39: v:=0.834*n-52.340;
        40..81: v:=0.467*n-38.095;
        82..134: v:=0.377*n-30.769;
        135..180: v:=0.436*n-38.667;
        181..210: v:=0.665*n-80;
        211..228: v:=1.153*n-182.941;
        229..237: v:=2.179*n-416.667;
        238..243: v:=3.565*n-745.455;
        244..245: v:=7.843*n-1784;
      else v:=140;
      end;}
      GrafObr.Canvas.MoveTo(abc,149-ceil(v));
        case Config.Temperature of
        1:n:=data[start+i+1,6];
        2:n:=255-data[start+i+1,6];
        end;
      case n of
        0..14:v:=(n - 5) * 2 - 60;
        15..38:v:=(n - 15) * 0.83 - 40;
        39..81:v:=(n - 39) * 0.47 - 20;
        82..134:v:=(n - 82) * 0.38;
        135..179:v:=(n - 135) * 0.44 + 20;
        180..209:v:=(n - 180) * 0.67 + 40;
        210..227:v:=(n - 210) * 1.11 + 60;
        228..236:v:=(n - 228) * 2.11 + 80;
        237..242:v:=(n - 237) * 3.83 + 99;
        243..255:v:=(n - 243) * 9.8 + 122;
      else v:=0;
      end;
      {case n of
        0..5:v:=-60;
        6..15:v:=2.064*n-70.526;
        16..39:v:=0.834*n-52.340;
        40..81:v:=0.467*n-38.095;
        82..134:v:=0.377*n-30.769;
        135..180:v:=0.436*n-38.667;
        181..210:v:=0.665*n-80;
        211..228:v:=1.153*n-182.941;
        229..237:v:=2.179*n-416.667;
        238..243:v:=3.565*n-745.455;
        244..245:v:=7.843*n-1784;
        246..255:v:=140;
      end;}
      GrafObr.Canvas.LineTo(abc2,149-ceil(V));
      end;

    case Config.DZ of
    1:if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=6 then
        begin
        TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='100';
        TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='50';
        TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
        GrafObr.Canvas.MoveTo(abc,199-data[start+i,7]);
        GrafObr.Canvas.LineTo(abc2,199-data[start+i+1,7]);
        end;
    2:if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=6 then
        begin
        TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='100%';
        TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='50%';
        TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0%';
        GrafObr.Canvas.MoveTo(abc,Round(199-data[start+i,7]*1.11));
        GrafObr.Canvas.LineTo(abc2,Round(199-data[start+i+1,7]*1.11));
        end;
    end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=7 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='200/';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='100/';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0/';
      GrafObr.Canvas.MoveTo(abc,199-data[start+i,8]);
      GrafObr.Canvas.LineTo(abc2,199-data[start+i+1,8]);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=8 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='5';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='2,5';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
      GrafObr.Canvas.MoveTo(abc,199-ceil(data[start+i,9]/1.28));
      GrafObr.Canvas.LineTo(abc2,199-ceil(data[start+i+1,9]/1.28));
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=9 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='5';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='2,5';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='0';
      GrafObr.Canvas.MoveTo(abc,199-ceil(data[start+i,10]/1.28));
      GrafObr.Canvas.LineTo(abc2,199-ceil(data[start+i+1,10]/1.28));
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=10 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi1[start+i,0] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi1[start+i+1,0] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=11 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi1[start+i,1] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi1[start+i+1,1] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=12 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi1[start+i,4] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi1[start+i+1,4] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=13 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi1[start+i,5] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi1[start+i+1,5] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=14 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi1[start+i,6] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi1[start+i+1,6] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=15 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,0] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,0] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=16 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,1] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,1] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=17 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,2] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,2] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=18 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,3] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,3] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=19 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,4] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,4] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=20 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,5] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,5] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=21 then
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+14))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+20))).Caption:='';
      TLabel(Form3.FindComponent('Label'+IntToStr(graf+26))).Caption:='';
      if flagi2[start+i,7] then n:=2
        else n:=198;
      GrafObr.Canvas.MoveTo(abc,n);
      if flagi2[start+i+1,7] then n:=2
        else n:=198;
      GrafObr.Canvas.LineTo(abc2,n);
      end;
    end;
GrafObr.Canvas.Pen.Width:=1;
end;

procedure Znacheniya(k:Integer;graf:Integer);
var
n:Integer;
v:Extended;
begin
    begin
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=0 then
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,1]*0.125,ffFixed,4,3)+' .';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=1 then
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,2]*0.47-30,ffFixed,3,1)+' .';
    case Config.KHH of
      1:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=2)then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,3]/255*100,ffFixed,3,1)+' %';
      2:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=2)then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,3],ffFixed,3,0)+' ';
    end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=3 then
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,4]*25,ffFixed,4,0)+' /';
    case Config.Vozduh of
      1:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,5]*0.6515,ffFixed,3,1)+' kPa';
      2:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,5]*4.886,ffFixed,4,0)+' ';
      3:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,5]*0.97,ffFixed,3,1)+' kPa';
      4:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,5]*7.732,ffFixed,4,0)+' ';

      5:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,5]*2,ffFixed,4,1)+' /';
      6:if (TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=4) then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,5]/255*5,ffFixed,3,1)+' ';
    end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=5 then
      begin
      case Config.Temperature of
        1:n:=data[k,6];
      else n:=255-data[k,6];
      end;
      case n of
        0..14:v:=(n - 5) * 2 - 60;
        15..38:v:=(n - 15) * 0.83 - 40;
        39..81:v:=(n - 39) * 0.47 - 20;
        82..134:v:=(n - 82) * 0.38;
        135..179:v:=(n - 135) * 0.44 + 20;
        180..209:v:=(n - 180) * 0.67 + 40;
        210..227:v:=(n - 210) * 1.11 + 60;
        228..236:v:=(n - 228) * 2.11 + 80;
        237..242:v:=(n - 237) * 3.83 + 99;
        243..255:v:=(n - 243) * 9.8 + 122;
      else v:=0;
      end;
      {case n of
        0..5:v:=-60;
        6..15:v:=2.064*n-70.526;
        16..39:v:=0.834*n-52.340;
        40..81:v:=0.467*n-38.095;
        82..134:v:=0.377*n-30.769;
        135..180:v:=0.436*n-38.667;
        181..210:v:=0.665*n-80;
        211..228:v:=1.153*n-182.941;
        229..237:v:=2.179*n-416.667;
        238..243:v:=3.565*n-745.455;
        244..245:v:=7.843*n-1784;
      else v:=140;
      end;}
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(V,ffFixed,3,1)+' .';
      end;
    case Config.DZ of
    1:if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=6 then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,7]/2,ffFixed,3,1)+' .';
    2:if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=6 then
        TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,7]/1.8,ffFixed,3,1)+' %';
    end;
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=7 then
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,8],ffFixed,3,0)+' /';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=8 then
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,9]*5/256,ffFixed,3,2)+'';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=9 then
      TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=FloatToStrF(data[k,10]*5/256,ffFixed,3,2)+'';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=10 then
      if flagi1[k,0] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=11 then
      if flagi1[k,1] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=12 then
      if flagi1[k,4] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=13 then
      if flagi1[k,5] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=14 then
      if flagi1[k,6] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=15 then
      if flagi2[k,0] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=16 then
      if flagi2[k,1] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=17 then
      if flagi2[k,2] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=18 then
      if flagi2[k,3] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=19 then
      if flagi2[k,4] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=20 then
      if flagi2[k,5] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(graf))).ItemIndex=21 then
      if flagi2[k,7] then TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:=''
        else TLabel(Form3.FindComponent('Label'+IntToStr(8+graf))).Caption:='';

    end;
end;

procedure RepaintCanvas();
var
i:Integer;
begin
Form3.Caption:='   '+IntToStr(Form3.ScrollBar1.Position)+'  '+IntToStr(Form3.ScrollBar1.Position+Mashtab-1)+' ';
GrafObr.Canvas.Pen.Color:=clBlack;
GrafObr.Canvas.Brush.Color := ClWhite;
GrafObr.Canvas.Rectangle(0,0,601,201);
for i:=3 to 32 do
  Tlabel(Form3.FindComponent('Label'+IntToStr(i))).Caption:='0';
GrafObr.Canvas.Pen.Style:=psDash;
GrafObr.Canvas.MoveTo(0,99);
GrafObr.Canvas.LineTo(599,99);
GrafObr.Canvas.MoveTo(0,49);
GrafObr.Canvas.LineTo(599,49);
GrafObr.Canvas.MoveTo(0,149);
GrafObr.Canvas.LineTo(599,149);

GrafObr.Canvas.Pen.Style:=psSolid;
end;

procedure PaintLine();
begin
  if Mashtab>1 then
    begin
    GrafObr.Canvas.Pen.Color:=clBlack;
    GrafObr.Canvas.Pen.Style:=psDash;
    GetLine(floor(Form3.TrackBar1.Position*(600/(Mashtab-1))));
    GrafObr.Canvas.MoveTo(floor(Form3.TrackBar1.Position*(600/(Mashtab-1))),0);
    GrafObr.Canvas.LineTo(floor(Form3.TrackBar1.Position*(600/(Mashtab-1))),199);
    GrafObr.Canvas.Pen.Style:=psSolid;
    end;
end;

procedure TForm3.FormRefresh(n:integer);
var
i:Integer;
begin
  RepaintCanvas;
  for i:=1 to 6 do
    if TComboBox(Form3.FindComponent('ComboBox'+IntToStr(i))).Text<>'' then
      begin
      PaintPanel(n,i);
      Znacheniya(n+Form3.TrackBar1.Position ,i);
      TLabel(Form3.FindComponent('Label'+IntToStr(i+14))).Visible:=True;
      TLabel(Form3.FindComponent('Label'+IntToStr(i+20))).Visible:=True;
      TLabel(Form3.FindComponent('Label'+IntToStr(i+26))).Visible:=True;
      TLabel(Form3.FindComponent('Label'+IntToStr(i+8))).Visible:=True;
      end
    else
      begin
      TLabel(Form3.FindComponent('Label'+IntToStr(i+14))).Visible:=False;
      TLabel(Form3.FindComponent('Label'+IntToStr(i+20))).Visible:=False;
      TLabel(Form3.FindComponent('Label'+IntToStr(i+26))).Visible:=False;
      TLabel(Form3.FindComponent('Label'+IntToStr(i+8))).Visible:=False;
      end;
  PaintLine();
  Form3.Image1.Canvas.Draw(0,0,GrafObr);
Form3.Label1.Caption:=IntTOStr(n+Form3.TrackBar1.Position);
end;

procedure TForm3.ScrollBar1Change(Sender: TObject);
begin
  FormRefresh(Form3.ScrollBar1.Position);
  Form1.ScrollBar1.Position:=Form3.ScrollBar1.Position+Form3.TrackBar1.Position;
end;

procedure TForm3.ComboBox1Change(Sender: TObject);
begin
  FormRefresh(Form3.ScrollBar1.Position);
  Form1.ScrollBar1.Position:=Form3.ScrollBar1.Position+Form3.TrackBar1.Position;
end;

procedure TForm3.FormShow(Sender: TObject);
begin
  Form3.SpeedButton1.Font.Color:=Config.col[1];
  Form3.SpeedButton2.Font.Color:=Config.col[2];
  Form3.SpeedButton3.Font.Color:=Config.col[3];
  Form3.SpeedButton4.Font.Color:=Config.col[4];
  Form3.SpeedButton5.Font.Color:=Config.col[5];
  Form3.SpeedButton6.Font.Color:=Config.col[6];

  Form3.ComboBox1.ItemIndex:=Config.GrafikN[1];
  Form3.ComboBox2.ItemIndex:=Config.GrafikN[2];
  Form3.ComboBox3.ItemIndex:=Config.GrafikN[3];
  Form3.ComboBox4.ItemIndex:=Config.GrafikN[4];
  Form3.ComboBox5.ItemIndex:=Config.GrafikN[5];
  Form3.ComboBox6.ItemIndex:=Config.GrafikN[6];

  SetColor;
  Mashtab:=Form1.ScrollBar1.Max;
  Form3.ComboBox8.Text:=IntToStr(Mashtab);
  Form3.TrackBar1.Max:=Mashtab-1;
  Form3.TrackBar1.Position:=ceil(Mashtab/2);
  FormRefresh(1);
  Form3.ScrollBar1.Position:=0;
  Form3.ComboBox8.Items.Clear;
  if Mashtab>4 then Form3.ComboBox8.Items.Add('5');
  if Mashtab>9 then Form3.ComboBox8.Items.Add('10');
  if Mashtab>19 then Form3.ComboBox8.Items.Add('20');
  if Mashtab>49 then Form3.ComboBox8.Items.Add('50');
  if Mashtab>99 then Form3.ComboBox8.Items.Add('100');
  if Mashtab>199 then Form3.ComboBox8.Items.Add('200');
  if Mashtab>499 then Form3.ComboBox8.Items.Add('500');
  if Mashtab>999 then Form3.ComboBox8.Items.Add('1000');
  if Mashtab>1999 then Form3.ComboBox8.Items.Add('2000');
  if Mashtab>5 then Form3.ComboBox8.Items.Add(IntToStr(Mashtab));

  //if kadr>Mashtab then Form3.ScrollBar1.Max:=kadr-Mashtab-1;
end;

procedure TForm3.ComboBox4Change(Sender: TObject);
var
granL,granH,TekKadr,MaxKadr:Integer;
begin
  TekKadr:=Form1.ScrollBar1.Position;
  MaxKadr:=Form1.ScrollBar1.Max;
  Mashtab:=StrToInt(Form3.ComboBox8.Text);
  if MaxKadr<Mashtab then Mashtab:=MaxKadr;
  granL:=TekKadr-ceil(Mashtab/2);
  granH:=granL+Mashtab;
  if granL<1 then
    begin
    granL:=1;
    granH:=Mashtab;
    Form3.ScrollBar1.Max:=MaxKadr-Mashtab+1;
    Form3.ScrollBar1.Position:=1;
    end;
  if granH>MaxKadr then
    begin
    granL:=MaxKadr-Mashtab+1;
    granH:=MaxKadr;
    Form3.ScrollBar1.Max:=MaxKadr-Mashtab+1;
    Form3.ScrollBar1.Position:=Form3.ScrollBar1.Max;
    end;
  if (granL>0) and (granH<MaxKadr+1) then
    begin
    Form3.ScrollBar1.Max:=MaxKadr-Mashtab+1;
    Form3.ScrollBar1.Position:=granL;
    end;
  Form3.ComboBox8.Text:=IntToStr(Mashtab);
  Form3.ScrollBar1.LargeChange:=ceil(Mashtab/5);
  Form3.TrackBar1.Max:=Mashtab-1;
  Form3.TrackBar1.Position:=TekKadr-Form3.ScrollBar1.Position;
  Form3.Caption:='   '+IntToStr(Form3.ScrollBar1.Position)+'  '+IntToStr(Form3.ScrollBar1.Position+Mashtab-1)+' ';
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.TrackBar1Change(Sender: TObject);
var
i:Integer;
begin
  WriteLine();
  PaintLine();
  Form1.ScrollBar1.Position:=Form3.ScrollBar1.Position+Form3.TrackBar1.Position;
  for i:=1 to 6 do
    Znacheniya(Form3.ScrollBar1.Position+Form3.TrackBar1.Position ,i);
  Form3.Label1.Caption:=IntTOStr(Form3.ScrollBar1.Position+Form3.TrackBar1.Position);
  Form3.Image1.Canvas.Draw(0,0,GrafObr);
end;

procedure TForm3.Button1Click(Sender: TObject);
begin
  if Form3.TrackBar1.Position>Form3.TrackBar1.Min then Form3.TrackBar1.Position:=Form3.TrackBar1.Position-1;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  if Form3.TrackBar1.Position<Form3.TrackBar1.Max then Form3.TrackBar1.Position:=Form3.TrackBar1.Position+1;
end;

procedure TForm3.SpeedButton1Click(Sender: TObject);
begin
  If Form3.ColorDialog1.Execute then
    Form3.SpeedButton1.Font.Color:=Form3.ColorDialog1.Color;
  Config.col[1]:=Form3.SpeedButton1.Font.Color;
  SetColor;
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.SpeedButton3Click(Sender: TObject);
begin
  If Form3.ColorDialog1.Execute then
    Form3.SpeedButton3.Font.Color:=Form3.ColorDialog1.Color;
  Config.col[3]:=Form3.SpeedButton3.Font.Color;
  SetColor;
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.SpeedButton4Click(Sender: TObject);
begin
  If Form3.ColorDialog1.Execute then
    Form3.SpeedButton4.Font.Color:=Form3.ColorDialog1.Color;
  Config.col[4]:=Form3.SpeedButton4.Font.Color;
  SetColor;
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.SpeedButton5Click(Sender: TObject);
begin
  If Form3.ColorDialog1.Execute then
    Form3.SpeedButton5.Font.Color:=Form3.ColorDialog1.Color;
  Config.col[5]:=Form3.SpeedButton5.Font.Color;
  SetColor;
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.SpeedButton6Click(Sender: TObject);
begin
  If Form3.ColorDialog1.Execute then
    Form3.SpeedButton6.Font.Color:=Form3.ColorDialog1.Color;
  Config.col[6]:=Form3.SpeedButton6.Font.Color;
  SetColor;
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.SpeedButton2Click(Sender: TObject);
begin
  If Form3.ColorDialog1.Execute then
    Form3.SpeedButton2.Font.Color:=Form3.ColorDialog1.Color;
  Config.col[2]:=Form3.SpeedButton2.Font.Color;
  SetColor;
  FormRefresh(Form3.ScrollBar1.Position);
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Config.GrafikN[1]:=Form3.ComboBox1.ItemIndex;
  Config.GrafikN[2]:=Form3.ComboBox2.ItemIndex;
  Config.GrafikN[3]:=Form3.ComboBox3.ItemIndex;
  Config.GrafikN[4]:=Form3.ComboBox4.ItemIndex;
  Config.GrafikN[5]:=Form3.ComboBox5.ItemIndex;
  Config.GrafikN[6]:=Form3.ComboBox6.ItemIndex;

  Form3.ComboBox1.Text:='';
  Form3.ComboBox2.Text:='';
  Form3.ComboBox3.Text:='';
  Form3.ComboBox4.Text:='';
  Form3.ComboBox5.Text:='';
  Form3.ComboBox6.Text:='';
end;

procedure TForm3.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then
    begin
    Form3.TrackBar1.Position:=Round(x/600*Form3.TrackBar1.Max);
    end;
end;

procedure TForm3.Button3Click(Sender: TObject);
begin
  Form1.Button5Click(Form3);
end;


end.
