unit Grafika;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit1, ExtCtrls,Math;

type
  TForm2 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Image4: TImage;
    Label4: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  Taho,Speed,Dross,Temper:TBitmap;

implementation

{$R *.dfm}

procedure TForm2.FormCreate(Sender: TObject);
begin
  //Form2.Width:=Screen.Width;
  //Form2.Height:=Screen.Height;
  Taho:= TBitmap.Create;
  Speed:= TBitmap.Create;
  Dross:= TBitmap.Create;
  Temper:= TBitmap.Create;
  Taho.LoadFromFile('Tahometr.bmp');
  Speed.LoadFromFile('Speedometr.bmp');
  Dross.LoadFromFile('Drossel.bmp');
  Temper.LoadFromFile('Temperature.bmp');
  Form2.Image1.Canvas.Draw(0,0,Taho);
  Form2.Image2.Canvas.Draw(0,0,Speed);
  Form2.Image3.Canvas.Draw(0,0,Dross);
  Form2.Image4.Canvas.Draw(0,0,Temper);
end;

procedure TForm2.Timer1Timer(Sender: TObject);
var
xob,yob,n:Integer;
v:Extended;
begin
  Form2.Timer1.Enabled:=False;
  if not(Form2.Visible) then Exit;
  Application.ProcessMessages;
  Form2.Image1.Canvas.Draw(0,0,Taho);
  xob:=75+Round(60*sin(5.495-data[Form1.ScrollBar1.Position,4]*0.0131)) ;
  yob:=75+Round(60*cos(5.495-data[Form1.ScrollBar1.Position,4]*0.0131));
  Form2.Image1.Canvas.Pen.Width:=5;
  Form2.Image1.Canvas.Pen.Color:=clRed;
  Form2.Image1.Canvas.MoveTo(75,75);
  Form2.Image1.Canvas.LineTo(xob,yob);

  Form2.Image2.Canvas.Draw(0,0,Speed);
  xob:=75+Round(60*sin(5.495-data[Form1.ScrollBar1.Position,8]*0.0262)) ;
  yob:=75+Round(60*cos(5.495-data[Form1.ScrollBar1.Position,8]*0.0262));
  Form2.Image2.Canvas.Pen.Width:=5;
  Form2.Image2.Canvas.Pen.Color:=clRed;
  Form2.Image2.Canvas.MoveTo(75,75);
  Form2.Image2.Canvas.LineTo(xob,yob);

  Form2.Image3.Canvas.Draw(0,0,Dross);
  xob:=75+Round(45*sin(data[Form1.ScrollBar1.Position,7]*0.0087)) ;
  yob:=75+Round(45*cos(data[Form1.ScrollBar1.Position,7]*0.0087));
  Form2.Image3.Canvas.Pen.Width:=5;
  Form2.Image3.Canvas.Pen.Color:=clRed;
  Form2.Image3.Canvas.MoveTo(150-xob,150-yob);
  Form2.Image3.Canvas.LineTo(xob,yob);

  case Temperature of
        1:n:=data[Form1.ScrollBar1.Position,6];
        2:n:=255-data[Form1.ScrollBar1.Position,6];
      end;
      case n of
        0..5:v:=-60;
        6..15:v:=2.064*n-70.526;
        16..39:v:=0.834*n-52.340;
        40..81:v:=0.467*n-38.095;
        82..134:v:=0.377*n-30.769;
        135..180:v:=0.436*n-38.667;
        181..210:v:=0.665*n-80;
        211..228:v:=1.153*n-182.941;
        229..237:v:=2.179*n-416.667;
        238..243:v:=3.565*n-745.455;
        244..245:v:=7.843*n-1784;
        246..255:v:=140;
      end;
  Form2.Image4.Canvas.Draw(0,0,Temper);
  xob:=75+Round(60*sin(4.45-v*0.0262)) ;
  yob:=75+Round(60*cos(4.45-v*0.0262));
  Form2.Image4.Canvas.Pen.Width:=5;
  Form2.Image4.Canvas.Pen.Color:=clRed;
  Form2.Image4.Canvas.MoveTo(75,75);
  Form2.Image4.Canvas.LineTo(xob,yob);
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  Form2.Timer1.Enabled:=True;
end;

end.
