unit Unit2;

interface

uses
  Classes, Unit1 , StdCtrls, Windows, SysUtils, Controls, Messages, Forms, Dialogs;

type
  PrPr = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

implementation

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure PrPr.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ PrPr }
function GetModem(var lpD:DWORD):boolean; stdcall;
begin
 Result:=GetCommModemStatus(hCom,lpD);
end;


procedure PrPr.Execute;
var
sp,told,tnew:int64;
data:Array[1..1000]of Int64;
max,sr,i:Integer;
fl:Dword;

begin
if not(QueryPerformanceFrequency(sp)) then
    begin
    Form1.Edit1.Text:='  :)';
    exit;
    end;

QueryPerformanceCounter(told);
  for i:=1 to 1000 do
    begin
    repeat
      Application.ProcessMessages;
      QueryPerformanceCounter(tnew);
    until (tnew>told+Round(sp*0.001*i));
    GetModem(fl);
    data[i]:=Round(tnew-(told+sp*0.001*i));
    end;
  sr:=0;
  max:=data[1];
  for i:=1 to 1000 do
    begin
    sr:=sr+data[i];
    if max<data[i] then max:=data[i];
    end;
  Application.ProcessMessages;
  Proizv:='   - '+FloatToStrF(sr/1000/sp*1000,ffFixed,5,4)+ '.'+'  - '+FloatToStrF(max/sp*1000,ffFixed,5,4)+ '.   2   .  .';
  Form1.Timer3.Enabled:=True;
  Application.ProcessMessages;
end;

end.
 