unit Unit9;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Unit1, IniFiles, Unit3, Unit7;

type
  TForm9 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Label3: TLabel;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Label4: TLabel;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    Edit1: TEdit;
    Label5: TLabel;
    Panel5: TPanel;
    Label6: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit3: TEdit;
    Label8: TLabel;
    Button1: TButton;
    CheckBox17: TCheckBox;
    CheckBox2: TCheckBox;
    Panel6: TPanel;
    Label9: TLabel;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox7MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox8MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox9MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox10MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox11MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox12MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox13MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox17MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure CheckBox19MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox18MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form9: TForm9;

implementation

uses Unit4, Unit5, Unit6, Unit8;

{$R *.dfm}

procedure Form9Refr;
var
i:Integer;
begin
  for i:=1 to 19 do
    TCheckBox(Form9.FindComponent('CheckBox'+IntToStr(i))).Checked:=False;
  for i:=1 to 3 do
    TEdit(Form9.FindComponent('Edit'+IntToStr(i))).Text:='';
  case Config.KHH of
    1:Form9.CheckBox1.Checked:=True;
    2:Form9.CheckBox3.Checked:=True;
    end;
  case Config.Temperature of
    1:Form9.CheckBox4.Checked:=True;
    2:Form9.CheckBox5.Checked:=True;
    end;
  case Config.Vozduh of
    1:Form9.CheckBox9.Checked:=True;
    2:Form9.CheckBox10.Checked:=True;
    4:Form9.CheckBox2.Checked:=True;
    3:Form9.CheckBox12.Checked:=True;
    5:Form9.CheckBox11.Checked:=True;
    6:Form9.CheckBox13.Checked:=True;
    end;
  case Config.DZ of
    1:Form9.CheckBox18.Checked:=True;
    2:Form9.CheckBox19.Checked:=True;
    end;
  case Config.StParam of
    0:Form9.CheckBox17.Checked:=True;
    1:Form9.CheckBox6.Checked:=True;
    2:Form9.CheckBox7.Checked:=True;
    3:Form9.CheckBox8.Checked:=True;
    end;
  if Config.InvAdapter then Form9.CheckBox14.Checked:=True;
  if Config.DTR then Form9.CheckBox15.Checked:=True;
  if Config.ZagrCP then Form9.CheckBox16.Checked:=True;
  Form9.Edit1.Text:=IntToStr(Config.PrFors);
  Form9.Edit2.Text:=IntToStr(Config.KolFors);
  Form9.Edit3.Text:=IntToStr(Config.ChastFors);
end;

procedure TForm9.Button1Click(Sender: TObject);
begin
  Form9.Close;
end;

function SetModCOM(baud:DWORD;bsize,parity,
                sbits:BYTE;DTR,RTS:boolean):boolean; stdcall;
begin
 dcb.BaudRate:=baud;
 dcb.Flags:=$00000001;
 if DTR then dcb.Flags:=dcb.Flags or $00000010;
 if RTS then dcb.Flags:=dcb.Flags or $00001000;
 dcb.ByteSize:=bsize;
 dcb.Parity:=parity;
 dcb.StopBits:=sbits;
 Result:=SetCommState(hCom,dcb);
end;

procedure TForm9.FormClose(Sender: TObject; var Action: TCloseAction);
var
i:Array[1..6] of Integer;
n:Integer;
begin
  if (StrToInt(Form9.Edit1.Text)<1) or (StrToInt(Form9.Edit1.Text)>500) then
    begin
    ShowMessage('  .');
    Action:=caNone;
    end;
  if (StrToInt(Form9.Edit2.Text)<1) or (StrToInt(Form9.Edit2.Text)>12) then
    begin
    ShowMessage('  .');
    Action:=caNone;
    end;
  if (StrToInt(Form9.Edit3.Text)<1) or (StrToInt(Form9.Edit3.Text)>4) then
    begin
    ShowMessage('   .');
    Action:=caNone;
    end;
  if Action<>caNone then
    begin
    Config.InvAdapter:=Form9.CheckBox14.Checked;
    Config.DTR:=Form9.CheckBox15.Checked;
    Config.ZagrCP:=Form9.CheckBox16.Checked;
    Config.PrFors:=StrToInt(Form9.Edit1.Text);
    Config.KolFors:=StrToInt(Form9.Edit2.Text);
    Config.ChastFors:=StrToInt(Form9.Edit3.Text);
    if Form1.ComboBox1.Text<>'' then Form1.ComboBox1Change(Form9);
    if Form1.Visible then Form1.ScrollBar1Change(Form9);
    if Form3.Visible then Form3.ScrollBar1Change(Form9);
    Form1.ComboADD;
    end;
end;

procedure TForm9.FormCreate(Sender: TObject);
var
MyIni: TIniFile;
begin
  MyIni:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'CarTesterByChem407.ini');
  if MyIni.ReadInteger('Main','Version',1001)<>Version then
    begin
    MyIni.EraseSection('Param');
    MyIni.EraseSection('FormPos');
    end;
  Config.Vozduh:=MyIni.ReadInteger('Param','Vozduh',1);
  Config.Temperature:=MyIni.ReadInteger('Param','Temperature',1);
  Config.KHH:=MyIni.ReadInteger('Param','KHH',1);
  Config.DZ:=MyIni.ReadInteger('Param','DZ',1);
  Config.StParam:=MyIni.ReadInteger('Param','Standart',1);
  Config.InvAdapter:=MyIni.ReadBool('Param','Adapter',False);
  Config.DTR:=MyIni.ReadBool('Param','DTR',False);
  Config.ZagrCP:=MyIni.ReadBool('Param','LowCP',True);
  Config.col[1]:=MyIni.ReadInteger('Param','col1',0);
  Config.col[2]:=MyIni.ReadInteger('Param','col2',0);
  Config.col[3]:=MyIni.ReadInteger('Param','col3',0);
  Config.col[4]:=MyIni.ReadInteger('Param','col4',0);
  Config.col[5]:=MyIni.ReadInteger('Param','col5',0);
  Config.col[6]:=MyIni.ReadInteger('Param','col6',0);

  Config.GrafikN[1]:=MyIni.ReadInteger('Param','Grafik1',-1);
  Config.GrafikN[2]:=MyIni.ReadInteger('Param','Grafik2',-1);
  Config.GrafikN[3]:=MyIni.ReadInteger('Param','Grafik3',-1);
  Config.GrafikN[4]:=MyIni.ReadInteger('Param','Grafik4',-1);
  Config.GrafikN[5]:=MyIni.ReadInteger('Param','Grafik5',-1);
  Config.GrafikN[6]:=MyIni.ReadInteger('Param','Grafik6',-1);

  Config.PrFors:=MyIni.ReadInteger('Param','PrFors',55);
  Config.KolFors:=MyIni.ReadInteger('Param','KolFors',4);
  Config.ChastFors:=MyIni.ReadInteger('Param','ChastFors',1);
  Form6.Edit1.Text:=MyIni.ReadString('Koment','Marka',' ');
  Form6.Edit2.Text:=MyIni.ReadString('Koment','DVS','');
  Form6.Edit3.Text:=MyIni.ReadString('Koment','Transm',' ');

  Form1.Left:=MyIni.ReadInteger('FormPos','1X',0);
  Form1.Top:=MyIni.ReadInteger('FormPos','1Y',0);
  Form3.Left:=MyIni.ReadInteger('FormPos','3X',0);
  Form3.Top:=MyIni.ReadInteger('FormPos','3Y',0);
  Form4.Left:=MyIni.ReadInteger('FormPos','4X',0);
  Form4.Top:=MyIni.ReadInteger('FormPos','4Y',0);
  Form5.Left:=MyIni.ReadInteger('FormPos','5X',0);
  Form5.Top:=MyIni.ReadInteger('FormPos','5Y',0);
  Form6.Left:=MyIni.ReadInteger('FormPos','6X',0);
  Form6.Top:=MyIni.ReadInteger('FormPos','6Y',0);
  Form7.Left:=MyIni.ReadInteger('FormPos','7X',0);
  Form7.Top:=MyIni.ReadInteger('FormPos','7Y',0);
  Form8.Left:=MyIni.ReadInteger('FormPos','8X',0);
  Form8.Top:=MyIni.ReadInteger('FormPos','8Y',0);
  Form9.Left:=MyIni.ReadInteger('FormPos','9X',0);
  Form9.Top:=MyIni.ReadInteger('FormPos','9Y',0);
  MyIni.Free;
end;

procedure SetNastr(n:Boolean);
var
i:Integer;
begin
  for i:=1 to 5 do
    TCheckBox(Form9.FindComponent('CheckBox'+IntToStr(i))).Enabled:=n;
  for i:=9 to 13 do
    TCheckBox(Form9.FindComponent('CheckBox'+IntToStr(i))).Enabled:=n;
end;

procedure TForm9.FormShow(Sender: TObject);
begin
  Form9Refr;
  if Config.StParam>0 then SetNastr(False);
end;

procedure TForm9.CheckBox6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.StParam:=1;
  Config.Vozduh:=1;
  Config.KHH:=1;
  Config.Temperature:=1;
  SetNastr(False);
  Form9Refr;
end;

procedure TForm9.CheckBox7MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.StParam:=2;
  Config.Vozduh:=6;
  Config.KHH:=1;
  Config.Temperature:=1;
  SetNastr(False);
  Form9Refr;
end;

procedure TForm9.CheckBox8MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.StParam:=3;
  Config.Vozduh:=6;
  Config.KHH:=1;
  Config.Temperature:=1;
  SetNastr(False);
  Form9Refr;
end;

procedure TForm9.CheckBox9MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Vozduh:=1;
  Form9Refr;
end;

procedure TForm9.CheckBox10MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Vozduh:=2;
  Form9Refr;
end;

procedure TForm9.CheckBox11MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Vozduh:=5;
  Form9Refr;
end;

procedure TForm9.CheckBox12MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Vozduh:=3;
  Form9Refr;
end;

procedure TForm9.CheckBox13MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Vozduh:=6;
  Form9Refr;
end;

procedure TForm9.CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.KHH:=1;
  Form9Refr;
end;

procedure TForm9.CheckBox2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Vozduh:=4;
  Form9Refr;
end;

procedure TForm9.CheckBox3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.KHH:=2;
  Form9Refr;
end;

procedure TForm9.CheckBox4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Temperature:=1;
  Form9Refr;
end;

procedure TForm9.CheckBox5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.Temperature:=2;
  Form9Refr;
end;

procedure TForm9.CheckBox17MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.StParam:=0;
  SetNastr(True);
  Form9Refr;
end;

procedure TForm9.FormDeactivate(Sender: TObject);
begin
  Form9.Close;
end;

procedure TForm9.CheckBox19MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.DZ:=2;
  Form9Refr;
end;

procedure TForm9.CheckBox18MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Config.DZ:=1;
  Form9Refr;
end;

end.
